from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('DisplayName')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereDisplayName");
  exportedObject.put("roleName", "WebSphereDisplayName");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.displayname.value", objid, "value","DisplayName");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.displayname.lang", objid, "lang","DisplayName");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('DisplayName');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('DisplayName')
  if not jsonobject.has("roleProperties"):
    raise Exception("DisplayName resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "value", roleProperties.optString("websphere.displayname.value", None));
  Util.addIfNotNone(properties, "lang", roleProperties.optString("websphere.displayname.lang", None));
  print "Creating DisplayName with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("DisplayName", parentid, properties);
  Util.popPathElement('DisplayName');

def update(objid,jsonobject):
  Util.pushPathElement('DisplayName')
  if not jsonobject.has("roleProperties"):
    raise Exception("DisplayName resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.displayname.value", None), "value","DisplayName");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.displayname.lang", None), "lang","DisplayName");
  if len(atts) != 0:
    print "Modifying DisplayName with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "DisplayName configuration up to date.";

  Util.popPathElement('DisplayName');
